exec("./modules/getName/getName.cs");
exec("./modules/zoomImage/zoomImage.cs");
exec("./modules/getFile/getFile.cs");

function addBind(%division, %name, %command)
{
	for(%i = 0; %i < $remapCount; %i++)
	{
		if($remapDivision[%i] $= %division)
		{
			%foundDiv = 1;

			continue;
		}

		if(%foundDiv && $remapDivision[%i] !$= "")
		{
			%position = %i;

			break;
		}
	}

	if(!%foundDiv)
	{
		error("Division not found:" SPC %division);

		return;
	}

	if(!%position)
	{
		$remapName[$remapCount] = %name;
		$remapCmd[$remapCount] = %command;
		$remapCount++;

		return;
	}

	for(%i = $remapCount; %i > %position; %i--)
	{
		$remapDivision[%i] = $remapDivision[%i - 1];
		$remapName[%i] = $remapName[%i - 1];
		$remapCmd[%i] = $remapCmd[%i - 1];
	}

	$remapDivision[%position] = "";
	$remapName[%position] = %name;
	$remapCmd[%position] = %command;
	$remapCount++;
}

function GuiControl::setExtent(%obj, %extent)
{
	%obj.resize(firstWord(%obj.getPosition()), getWord(%obj.getPosition(), 1), firstWord(%extent), getWord(%extent, 1));
}

function findClosestColor(%x)
{
	for(%a = 0; %a < 64; %a++)
	{
		%match = mAbs(firstWord(getColorIDTable(%a)) - firstWord(%x)) + mAbs(getWord(getColorIDTable(%a), 1) - getWord(%x, 1)) + mAbs(getWord(getColorIDTable(%a), 2) - getWord(%x, 2)) + mAbs(getWord(getColorIDTable(%a), 3) - getWord(%x, 3)) * 4;

		if(%match < %bestMatch || %bestMatch $= "")
		{
			%bestMatch = %match;
			%bestID = %a;
		}
	}

	return %bestID;
}

function findMaxTransColor()
{
	for(%a = 0; %a < 64; %a++)
	{
		%match = getColorIDTable(%a);
		%matchAlpha = getWord(%match, 3);

		if(%bestMatch $= "" || %matchAlpha < getWord(%bestMatch, 3) && %matchAlpha > 0)
		{
			%bestMatch = %match;
			%bestID = %a;
		}
	}

	return %bestID;
}

function mRound(%num)
{
	return mFloor(%num + 0.5);
}

function guiBitmapCtrl::getRealPixelColor(%obj, %x, %y)
{
	%realY = -2 * getWord(%obj.getScreenPosition(), 1);
	%realY += getWord(getRes(), 1) - %y;
	%realY--;

	return %obj.getPixelColor(%x, %realY);
}

//Function by Red_Guy
function addCommaR(%aString)
{
	%len = strlen(%aString);

	if(%len < 4)
		return %aString;

	%last = getSubStr(%aString, %len - 3, 3);
	%first = getSubStr(%aString, 0, %len - 3);
	%part = addCommaR(%first);

	return %part @ "," @ %last;
}

function minClamp(%num, %min)
{
	if(%num <= %min)
		return %min;

	return %num;
}